//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Copyright 2010: A3 Labs, Inc. (http://a3labs.com)
// Creative Commons Liscence: http://creativecommons.org/licenses/by-nc/3.0/
// Attribution-NonCommercial 3.0 Unported
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//>> Settings File
System.Gadget.settingsUI = "Settings.html";

//>> Timers
var Timer_Pause, Timer_Update;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Init
//  PARAMS >> None
//*************************************************************
function GADGET_Init()
{
	UTIL.STOR_Load();
	
	//>> Variables
	var FB_Access          = UTIL.VAR_Read("FB_Access");
	var Font_Family        = UTIL.VAR_Read("Font_Family", "Trebuchet MS");
	var Interval_Update    = UTIL.VAR_Read("Interval_Update", 10);
	var Mode               = UTIL.VAR_Read("Mode", "Full");
	var Show_Friends_List  = UTIL.VAR_Read("Show_Friends_List", "On");
	var Show_Logo_Link     = UTIL.VAR_Read("Show_Logo_Link", "On");
	var Show_Notifications = UTIL.VAR_Read("Show_Notifications", "On");
	var Theme              = UTIL.VAR_Read("Theme", "1");
	
	//>> Set Theme
	UTIL.FILE_Include_CSS("CSS/Theme-" + Theme + ".css", true);
	$B_BG("url('Images/Themes/" + Theme + "/BG-Gadget.png')");
	$S_Class("Gadget", "T" + Theme);
	
	//>> Set Font
	$B_Font(Font_Family + ", sans-serif");
	
	//>> Determine Login
	if (FB_Access == '')
	{
		UTIL.VAR_Write("Temp_Panel", "Login");
		$S_Hide("UI-Button-Omni");
		GADGET_Mode("Full");
		GADGET_Panel("Login");
	}
	else
	{
		UTIL.VAR_Write("Temp_Panel", "Main");
		$S_Show("UI-Button-Omni");
		GADGET_Panel("Main");
		
		if (Mode == "Full")
		{
			if (Show_Logo_Link == "Off") $S_Hide("UI-Logo-Link");
			if (Show_Friends_List == "Off") $S_Hide("Friends-Button-Friends-List");
			if (Show_Notifications == "Off") $S_Hide("Me-Button-Notifications");
		}
		
		UTIL.VAR_Write("Offline", "Off");
		UTIL.VAR_Write("Temp_Stream_Flag", '');
		if (Timer_Update) clearInterval(Timer_Update);
		if (Interval_Update != '' && Interval_Update != "Off")
		{
			Interval_Update = Interval_Update * 60000;
			Timer_Update = setInterval(GADGET_Feed_Refresh, Interval_Update);
		}
		GADGET_Feed_Refresh();
	}
	
	//>> Set Gadget Size
	System.Gadget.onDock = GADGET_Resize;
	System.Gadget.onUndock = GADGET_Resize;
	GADGET_Resize();
}

//*************************************************************
//  GADGET >> Resize
//  PARAMS >> None
//*************************************************************
function GADGET_Resize()
{
	//>> Variables
	var Corners     = UTIL.VAR_Read("Corners", "Rounded");
	var Mode        = UTIL.VAR_Read("Mode", "Full");
	var Size_Dock   = UTIL.VAR_Read("Size_Dock", "SM");
	var Size_UnDock = UTIL.VAR_Read("Size_UnDock", "LG");
	var Size_Height = UTIL.VAR_Read("Size_Height", "1");
	var Height, Size, Str;

	//>> Determine / Save Size
	if (System.Gadget.docked) { Size = Size_Dock }
	else { Size = Size_UnDock }
	UTIL.VAR_Write("Temp_Size", Size);

	//>> Width Resize
	if (Size == "SM") { $B_Width(130) }
	else { $B_Width(240) }

	//>> Height Resize / 250 Min. Full / 100 Mini
	if (Mode == "Mini") { Height = 100 }
	else { Height = 200 + Size_Height * 50 }
	$B_Height(Height - 1);
	window.setTimeout("$B_Height(" + Height + ")", 200);
	$S("UI-Body").style.height = Height - 40;

	//>> Set Border
	Str = "<img src='Images/Rim/Border-TB.png' style='position: absolute; top: 0; left: 0;' />";
	Str += "<img src='Images/Rim/Border-TB.png' style='position: absolute; bottom: 0; left: 0;' />";
	Str += "<img src='Images/Rim/Border-LR.png' style='position: absolute; top: 0; left: 0;' />";
	Str += "<img src='Images/Rim/Border-LR.png' style='position: absolute; top: 0; right: 0;' />";
	if (Corners != "Off")
	{
		Str += "<img src='Images/Rim/Corner-" + Corners + "-TL.png' style='position: absolute; top: 0; left: 0;' />";
		Str += "<img src='Images/Rim/Corner-" + Corners + "-TR.png' style='position: absolute; top: 0; right: 0;' />";
		Str += "<img src='Images/Rim/Corner-" + Corners + "-BL.png' style='position: absolute; bottom: 0; left: 0;' />";
		Str += "<img src='Images/Rim/Corner-" + Corners + "-BR.png' style='position: absolute; bottom: 0; right: 0;' />";
	}
	$S_HTML("Gadget-Border", Str);
	
	//>> ReClass Elements
	GADGET_ReClass(Size, Size_Height);
}

//*************************************************************
//  GADGET >> ReClass
//  PARAMS >> Size        | String
//  PARAMS >> Size_Height | Int
//*************************************************************
function GADGET_ReClass(Size, Size_Height)
{
	var Panel = UTIL.VAR_Read("Temp_Panel", "Login");
	$S_Class("UI-Logo-Link", "UI-Logo-Link-" + Size);
	if (Panel == "Main")
	{
		var Mode              = UTIL.VAR_Read("Mode", "Full");
		var User_Status 	  = UTIL.VAR_Read("Temp_User_Status");
		var Show_Friends_List = UTIL.VAR_Read("Show_Friends_List", "On");
		if (Show_Friends_List == "On") var Stream_Minus = 18;
		else { var Stream_Minus = 0 }
		
		if (Mode == "Full")
		{
			$S_Class("Bottom-Button-Me", "Bottom-Button-Me-" + Size);
			$S_Class("Bottom-Button-Menu", "Bottom-Button-Menu-" + Size);
			$S_Class("Bottom-Button-Friends", "Bottom-Button-Friends-" + Size);
			
			$S_Class("Me-Status-Box", "Me-Status-Box-" + Size);
			$S_Class("Me-Status-Box-Decor", "Me-Status-Box-Decor-" + Size);
			$S_Class("Me-Status-Button", "Me-Status-Button-" + Size);
			
			$S_Class("Me-Button-Notifications-Count", "Me-Button-Notifications-Count-" + Size);
			if ($S("Me-Button-Notifications").className.indexOf("Active") > -1) $S_Class("Me-Button-Notifications", "Me-Button-Notifications-" + Size + "-Active");
			else { $S_Class("Me-Button-Notifications", "Me-Button-Notifications-" + Size) }
			
			$S_Class("Me-Messages", "Me-Messages-" + Size);
			$S_Class("Me-Message-Poke-Title", "Me-Message-Title Me-Message-Title-" + Size);
			$S_Class("Me-Message-Msg-Title", "Me-Message-Title Me-Message-Title-" + Size);
			$S_Class("Me-Message-Friend-Title", "Me-Message-Title Me-Message-Title-" + Size);
			$S_Class("Me-Message-Events-Title", "Me-Message-Title Me-Message-Title-" + Size);
			$S_Class("Me-Message-Groups-Title", "Me-Message-Title Me-Message-Title-" + Size);
			
			$S_Class("Friends-Button-Up", "Friends-Button-Up-" + Size);
			$S_Class("Friends-Button-Down", "Friends-Button-Down-" + Size);
			$S_Class("Friends-Button-Friends-List", "Friends-Button-Friends-List-" + Size);
			
			$S_Class("Friends-Stream-Outer", "Friends-Stream-" + Size);
			$S("Friends-Stream-Outer").style.height = 120 + (Size_Height * 50) - Stream_Minus;
			$S_Class("Friends-Stream", "Friends-Stream-" + Size);
			$S("Friends-Stream").style.height = 120 + (Size_Height * 50) - Stream_Minus;
			$S_Class("Scrollholder", "Friends-Stream-Scrollholder Friends-Stream-Scrollholder-" + Size);
			$S("Scrollholder").style.height = 120 + (Size_Height * 50) - Stream_Minus;
			$S_Class("Scroll", "Friends-Stream-Scroll Friends-Stream-Scroll-" + Size);
			
			if ($S("Gadget-User").innerText != '') GADGET_Feed_Display_User();
			if ($S("Gadget-Stream").innerText != '') GADGET_Feed_Display_Stream();
			GADGET_Section(UTIL.VAR_Read("Temp_Section", "Me"));
		}
		else
		{
			$S_Class("Bottom-Button-Menu", "Bottom-Button-Menu-" + Mode);
			$S_Class("Mini-Message-Poke", "Mini-Message-" + Size);
			$S_Class("Mini-Message-Msg", "Mini-Message-" + Size);
			$S_Class("Mini-Message-Friend", "Mini-Message-" + Size);
			$S_Class("Mini-Message-Events", "Mini-Message-" + Size);
			$S_Class("Mini-Message-Groups", "Mini-Message-" + Size);
			$S_Class("Mini-Message-Notif", "Mini-Message-" + Size);
			GADGET_Feed_Display_Mini();
		}
	}
}

//*************************************************************
//  GADGET >> Launch
//  PARAMS >> Type (String)
//*************************************************************
function GADGET_Launch(Type)
{
	try
	{
		if (Type == "Facebook") UTIL.Shell.Run(INFO.URL_FB_Website);
		else if (Type == "Profile") UTIL.Shell.Run(INFO.URL_FB_Profile + UTIL.VAR_Read("FB_UID"));
		else if (Type == "Pokes") UTIL.Shell.Run(INFO.URL_FB_Pokes);
		else if (Type == "Messages") UTIL.Shell.Run(INFO.URL_FB_Messages);
		else if (Type == "Friend_Req") UTIL.Shell.Run(INFO.URL_FB_Friend_Req);
		else if (Type == "Events") UTIL.Shell.Run(INFO.URL_FB_Events);
		else if (Type == "Groups") UTIL.Shell.Run(INFO.URL_FB_Groups);
		else if (Type == "Notifications") UTIL.Shell.Run(INFO.URL_FB_Notif);
		else { UTIL.Shell.Run(Type) }
	}
	catch(e){}
}

//*************************************************************
//  GADGET >> Link Check
//  PARAMS >> Txt (String)
//*************************************************************
function GADGET_Link_Check(Txt)
{
	var i;
	var Str = '';
	var Res = Txt.split(' ');
	for (i in Res)
	{
		var X = Res[i];
		if (X.match("http:") || X.match("https:"))
			X = "[link]";
		Str += X + " ";
	}
	return Str
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Mode
//  PARAMS >> Mode | String
//*************************************************************
function GADGET_Mode(Mode)
{
	UTIL.VAR_Write("Mode", Mode);
	GADGET_Panel(UTIL.VAR_Read("Temp_Panel", "Login"));
	GADGET_Resize();
	UTIL.STOR_Save();
}

//*************************************************************
//  GADGET >> Mode: Offline
//  PARAMS >> Offline | String
//*************************************************************
function GADGET_Mode_Offline(Offline)
{
	try
	{
		UTIL.VAR_Write("Offline", Offline);
		UTIL.STOR_Save();
		if (Offline == "On")
		{
			var Feed_User = UTIL.JSON_Decode(UTIL.FILE_Load("FB-Data-User.txt"));
			if (Feed_User != '')
			{
				var Feed_Stream = UTIL.FILE_Load("FB-Data-Stream.txt");
				$S_Text("Gadget-Stream", Feed_Stream);
				$S_Text("Gadget-User", Feed_User);
				$S_Class("UI-Button-Omni", "UI-Button-Omni-Offline");
				$S("UI-Button-Omni").title = "Gadget in Offline Mode";
				GADGET_Feed_Display_User();
				GADGET_Feed_Display_Stream();
			}
			else { GADGET_OMNI_Alert("Previous data not loading. It may not exist.") }
		}
		else
		{
			$S_Class("UI-Button-Omni", "UI-Button-Omni-Gear");
			$S("UI-Button-Omni").title = "Quick Options / Alerts";
			GADGET_Feed_Refresh();
		}
	}
	catch(e){}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> OMNI: Alert
//  PARAMS >> Alert | String
//*************************************************************
function GADGET_OMNI_Alert(Alert)
{
	UTIL.VAR_Write("Temp_Alert", Alert);
	$S_Class("UI-Button-Omni", "UI-Button-Omni-Alert");
	$S("UI-Button-Omni").title = "Alert!"
}

//*************************************************************
//  GADGET >> OMNI: Clear Alert
//  PARAMS >> None
//*************************************************************
function GADGET_OMNI_Clear_Alert()
{
	UTIL.VAR_Write("Temp_Alert", '');
	if (UTIL.VAR_Read("Offline", "Off") == "On")
	{
		$S_Class("UI-Button-Omni", "UI-Button-Omni-Offline");
		$S("UI-Button-Omni").title = "Gadget in Offline Mode";
	}
	else
	{
		$S_Class("UI-Button-Omni", "UI-Button-Omni-Gear");
		$S("UI-Button-Omni").title = "Quick Options / Alerts";
	}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Panel
//  PARAMS >> Panel | String
//*************************************************************
function GADGET_Panel(Panel)
{
	var Mode = UTIL.VAR_Read("Mode", "Full");
	var Size = UTIL.VAR_Read("Temp_Size", "SM");
	var Str  = '';
	var Str2 = '';

	if (Panel == "Login")
	{
		Str += "<div id='Login-Label' class='UI-Label'></div>";
		Str += "<div id='Login-Button-Connect' onclick='GADGET_Login_Connect();'></div>";
		Str += "<div style='margin-top: 15px;'>    .</div>";
		Str += "<div id='Login-Button-Next' onclick='GADGET_Login_Start();'></div>";
	}
	else if (Panel == "Main")
	{
		if (Mode == "Full")
		{
			Str += "<div id='Main-Sec-Me' class='Hidden'>";
			
				Str += "<div id='Me-Label' class='UI-Label' onclick='GADGET_Flyout_User();'>";
					Str += "<div id='Me-Label-Loading'>Loading...</div>";
					Str += "<div id='Me-Label-Main' class='Hidden'>";
						Str += "<div id='Me-Label-Icon'></div>";
						Str += "<div id='Me-Label-Name-SM' class='Me-Label-Name'>";
							Str += "<div id='Me-Label-Name-SM-Top'></div>";
							Str += "<div id='Me-Label-Name-SM-Bottom'></div>";
						Str += "</div>";
						Str += "<div id='Me-Label-Name-LG' class='Me-Label-Name'>";
							Str += "<div id='Me-Label-Name-LG-Top'></div>";
							Str += "<div id='Me-Label-Name-LG-Bottom'></div>";
						Str += "</div>";
					Str += "</div>";
				Str += "</div>";
				
				Str += "<div id='Me-Status'>";
					Str += "<div id='Me-Status-Box'></div>";
					Str += "<div id='Me-Status-Box-Decor'></div>";
					Str += "<div id='Me-Status-Button' onclick='GADGET_Flyout_Status();'></div>";
				Str += "</div>";
				
				Str += "<div id='Me-Button-Notifications' onclick='GADGET_Flyout_Notifications();'>";
					Str += "<span id='Me-Button-Notifications-Count'></span>";
				Str += "</div>";
				
				Str += "<div id='Me-Messages'>";
					Str += "<div id='Me-Message-Poke' class='Me-Message-Entry Me-Message-Entry-Line' onclick='GADGET_Launch(\"Pokes\");'>";
						Str += "<div id='Me-Message-Poke-Icon' class='Me-Message-Icon'></div>";
						Str += "<div id='Me-Message-Poke-Title'></div>";
						Str += "<div id='Me-Message-Poke-Count' class='Me-Message-Count'></div>";
					Str += "</div>";
					Str += "<div id='Me-Message-Msg' class='Me-Message-Entry Me-Message-Entry-Line' onclick='GADGET_Launch(\"Messages\");'>";
						Str += "<div id='Me-Message-Msg-Icon' class='Me-Message-Icon'></div>";
						Str += "<div id='Me-Message-Msg-Title'></div>";
						Str += "<div id='Me-Message-Msg-Count' class='Me-Message-Count'></div>";
					Str += "</div>";
					Str += "<div id='Me-Message-Friend' class='Me-Message-Entry Me-Message-Entry-Line' onclick='GADGET_Launch(\"Friend_Req\");'>";
						Str += "<div id='Me-Message-Friend-Icon' class='Me-Message-Icon'></div>";
						Str += "<div id='Me-Message-Friend-Title'> ?.</div>";
						Str += "<div id='Me-Message-Friend-Count' class='Me-Message-Count'></div>";
					Str += "</div>";
					Str += "<div id='Me-Message-Events' class='Me-Message-Entry Me-Message-Entry-Line' onclick='GADGET_Launch(\"Events\");'>";
						Str += "<div id='Me-Message-Events-Icon' class='Me-Message-Icon'></div>";
						Str += "<div id='Me-Message-Events-Title'></div>";
						Str += "<div id='Me-Message-Events-Count' class='Me-Message-Count'></div>";
					Str += "</div>";
					Str += "<div id='Me-Message-Groups' class='Me-Message-Entry' onclick='GADGET_Launch(\"Groups\");'>";
						Str += "<div id='Me-Message-Groups-Icon' class='Me-Message-Icon'></div>";
						Str += "<div id='Me-Message-Groups-Title'> .?</div>";
						Str += "<div id='Me-Message-Groups-Count' class='Me-Message-Count'></div>";
					Str += "</div>";
				Str += "</div>";
								
			Str += "</div>";
			Str += "<div id='Main-Sec-Friends' class='Hidden'>";
			
				Str += "<div class='UI-Label'>Friend Activity</div>";
				Str += "<div id='Friends-Button-Up' onmousedown='GADGET_Stream_Up(\"Go\");' onmouseup='GADGET_Stream_Up();' onmouseout='GADGET_Stream_Up();'></div>";
				Str += "<div id='Friends-Stream-Outer'>";
					Str += "<div id='Friends-Stream'>";
						Str += "<div id='Scrollholder'>";
							Str += "<div id='Scroll'></div>";
						Str += "</div>";
					Str += "</div>";
				Str += "</div>";
				Str += "<div id='Friends-Button-Down' onmousedown='GADGET_Stream_Down(\"Go\");' onmouseup='GADGET_Stream_Down();' onmouseout='GADGET_Stream_Down();'></div>";
				Str += "<div id='Friends-Button-Friends-List' onclick='GADGET_Flyout_Friends();'></div>";
				
			Str += "</div>";
			
			//>> Bottom Buttons
			Str2 += "<div id='Bottom-Button-Me' onclick='GADGET_Section(\"Me\");'><div id='Bottom-Button-Me-Icon' class='Bottom-Button-Icon'></div></div>";
			Str2 += "<div id='Bottom-Button-Menu' onclick='GADGET_Flyout_Menu();' title='Menu'><div id='Bottom-Button-Menu-Icon' class='Bottom-Button-Icon-Center'></div></div>";
			Str2 += "<div id='Bottom-Button-Friends' onclick='GADGET_Section(\"Friends\");'><div id='Bottom-Button-Friends-Icon' class='Bottom-Button-Icon'></div></div>";
		}
		else if (Mode == "Mini")
		{
			Str += "<div class='Mini-Messages'>";
				Str += "<div id='Mini-Message-Poke' onclick='GADGET_Launch(\"Pokes\");' title='Pokes'>";
					Str += "<div id='Me-Message-Poke-Icon' class='Me-Message-Icon'></div>";
					Str += "<div id='Mini-Message-Poke-Count' class='Mini-Message-Count'>0</div>";
				Str += "</div>";
				Str += "<div id='Mini-Message-Msg' onclick='GADGET_Launch(\"Messages\");' title='Messages'>";
					Str += "<div id='Me-Message-Msg-Icon' class='Me-Message-Icon'></div>";
					Str += "<div id='Mini-Message-Msg-Count' class='Mini-Message-Count'>0</div>";
				Str += "</div>";
				Str += "<div id='Mini-Message-Friend' onclick='GADGET_Launch(\"Friend_Req\");' title='Friend Requests'>";
					Str += "<div id='Me-Message-Friend-Icon' class='Me-Message-Icon'></div>";
					Str += "<div id='Mini-Message-Friend-Count' class='Mini-Message-Count'>0</div>";
				Str += "</div>";
				
				Str += "<div id='Mini-Message-Events' onclick='GADGET_Launch(\"Events\");' title='Event Invites'>";
					Str += "<div id='Me-Message-Events-Icon' class='Me-Message-Icon'></div>";
					Str += "<div id='Mini-Message-Events-Count' class='Mini-Message-Count'>0</div>";
				Str += "</div>";
				Str += "<div id='Mini-Message-Groups' onclick='GADGET_Launch(\"Groups\");' title='Group Invites'>";
					Str += "<div id='Me-Message-Groups-Icon' class='Me-Message-Icon'></div>";
					Str += "<div id='Mini-Message-Groups-Count' class='Mini-Message-Count'>0</div>";
				Str += "</div>";
				Str += "<div id='Mini-Message-Notif' onclick='GADGET_Flyout_Notifications();' title='Notifications'>";
					Str += "<div id='Me-Message-Notif-Icon' class='Me-Message-Icon'></div>";
					Str += "<div id='Mini-Message-Notif-Count' class='Mini-Message-Count'>0</div>";
				Str += "</div>";
			Str += "</div>";
		
			//>> Bottom Button
			Str2 += "<div id='Bottom-Button-Menu' onclick='GADGET_Flyout_Menu();' title='Menu'><div id='Bottom-Button-Menu-Icon' class='Bottom-Button-Icon-Center'></div></div>";
		}
	}
	$S_HTML("UI-Body", Str);
	$S_HTML("UI-Bottom", Str2);
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Login: Connect
//  PARAMS >> None
//*************************************************************
function GADGET_Login_Connect()
{
	var Unix = new Date().getTime();
	var Code = Unix + "_" + UTIL.STR_Code(15);
	UTIL.VAR_Write("Temp_Login_Code", Code);
	UTIL.Shell.Run(INFO.URL_FB_OpenAuth + "&scope=read_stream,publish_stream,offline_access&redirect_uri=" + INFO.URL_FB_Redirect + Code);
	setTimeout('$S_Show("Login-Button-Next")', 2000);
}

//*************************************************************
//  GADGET >> Login (Start)
//  PARAMS >> None
//*************************************************************
function GADGET_Login_Start()
{
	try
	{
		$S_HTML("Login-Label", "Sending...");
		AJAX_Login = UTIL.AJAX_Create(GADGET_Login_Mid, "POST", INFO.URL_FB_Retrieve, true);
		AJAX_Login.send("track_id=" + UTIL.VAR_Read("Temp_Login_Code"));
	}
	catch(e) { $S_HTML("Login-Label", "<span style='color: #800;'>Connect Error</span>"); }
}

//*************************************************************
//  GADGET >> Login (Mid)
//  PARAMS >> None
//*************************************************************
function GADGET_Login_Mid()
{
	if (UTIL.AJAX_Check(AJAX_Login)) 
	{
		try
		{
			var Res = AJAX_Login.responseText;
			if (Res != "False" && Res != '')
			{
				UTIL.VAR_Write("FB_Access", Res);
				$S_HTML("Login-Label", "Fetching ID...");
				AJAX_Login = UTIL.AJAX_Create(GADGET_Login_End, "GET", INFO.URL_FB_Graph_User + UTIL.VAR_Read("FB_Access"), true);
				AJAX_Login.send()
			}
			else { $S_HTML("Login-Label", "<span style='color: #800;'>Connect Error</span>"); }
		}
		catch(e){}
	}
}

//*************************************************************
//  GADGET >> Login (End)
//  PARAMS >> None
//*************************************************************
function GADGET_Login_End()
{
	if (UTIL.AJAX_Check(AJAX_Login, true)) 
	{
		try
		{
			var Res = UTIL.JSON_Parse(AJAX_Login.responseText);
			UTIL.VAR_Write("FB_UID", Res.id);
			UTIL.STOR_Save();
			GADGET_Init();
		}
		catch(e){}
	}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Flyout: Omni
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_Omni()
{
	System.Gadget.Flyout.onHide = function()
	{
		if (UTIL.VAR_Read("Temp_Flag_Omni_Mode") == "On")
		{
			UTIL.VAR_Write("Temp_Flag_Omni_Mode", '');
			GADGET_Mode(UTIL.VAR_Read("Mode", "Full"))
		}
		if (UTIL.VAR_Read("Temp_Flag_Omni_Offline") == "On")
		{
			UTIL.VAR_Write("Temp_Flag_Omni_Offline", '');
			GADGET_Mode_Offline(UTIL.VAR_Read("Offline", "Off"))
		}
		if (UTIL.VAR_Read("Temp_Flag_Omni_Refresh") == "On")
		{
			UTIL.VAR_Write("Temp_Flag_Omni_Refresh", '');
			GADGET_Feed_Refresh()
		}
	};
	UTIL.FLYOUT_Open("Omni", true)
}

//*************************************************************
//  GADGET >> Flyout: Menu
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_Menu()
{
	var Mode = UTIL.VAR_Read("Mode", "Full");
	var Size = UTIL.VAR_Read("Temp_Size", "SM");
	
	GADGET_Flyout_Button_Reset();
	
	if (Mode == "Full")	$S_Class("Bottom-Button-Menu", "Bottom-Button-Menu-" + Size + "-Active");
	else { $S_Class("Bottom-Button-Menu", "Bottom-Button-Menu-Mini-Active") }
	
	System.Gadget.Flyout.onHide = function() { GADGET_Flyout_Button_Reset(); };
	UTIL.FLYOUT_Open("Menu", true)
}

//*************************************************************
//  GADGET >> Flyout: Menu Alt
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_Menu_Alt()
{
	GADGET_Flyout_Button_Reset();
	UTIL.FLYOUT_Open("Menu")
}

//*************************************************************
//  GADGET >> Flyout: User
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_User()
{
	GADGET_Flyout_Button_Reset();
	if (UTIL.VAR_Read("Profile_Link", "Wall") == "Wall") { UTIL.FLYOUT_Open("User") }
	else { GADGET_Launch("Profile") }
}

//*************************************************************
//  GADGET >> Flyout: Status
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_Status()
{
	GADGET_Flyout_Button_Reset();
	UTIL.FLYOUT_Open("Status")
}

//*************************************************************
//  GADGET >> Flyout: Notifications
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_Notifications()
{
	GADGET_Flyout_Button_Reset();
	if (UTIL.VAR_Read("Mode", "Full") == "Full")
	{
		$S_HTML("Me-Button-Notifications-Count", '');
		$S_Class("Me-Button-Notifications", "Me-Button-Notifications-" + UTIL.VAR_Read("Temp_Size", "SM"));
	}
	System.Gadget.Flyout.onHide = function() { GADGET_Flyout_Button_Reset(); };
	UTIL.FLYOUT_Open("Notifications", true)
}

//*************************************************************
//  GADGET >> Flyout: Friends
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_Friends()
{
	GADGET_Flyout_Button_Reset();
	UTIL.FLYOUT_Open("Friends")
}

//*************************************************************
//  GADGET >> Flyout: Friend Activity
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_Friend_Activity()
{
	GADGET_Flyout_Button_Reset();
	UTIL.FLYOUT_Open("Friend-Activity")
}

//*************************************************************
//  GADGET >> Flyout: Entry
//  PARAMS >> ID (String)
//*************************************************************
function GADGET_Flyout_Entry(ID)
{
	GADGET_Flyout_Button_Reset();
	UTIL.VAR_Write("Temp_Entry_ID", ID);
	if (UTIL.VAR_Read("Override_Stream", "On") == "On")
	{
		System.Gadget.Flyout.onHide = function()
		{
			if (UTIL.VAR_Read("Temp_Stream_Comment") != '')
			{
				GADGET_Refresh_Stream_Start();
				UTIL.VAR_Write("Temp_Stream_Comment",'');
			}
		};
	}
	else { System.Gadget.Flyout.onHide = function(){}; }
	UTIL.FLYOUT_Open("Entry", true)
}

//*************************************************************
//  GADGET >> Flyout: Button Reset
//  PARAMS >> None
//*************************************************************
function GADGET_Flyout_Button_Reset()
{
	try
	{
		var Mode = UTIL.VAR_Read("Mode", "Full");
		var Size = UTIL.VAR_Read("Temp_Size", "SM");
	
		if (Mode == "Full")	$S_Class("Bottom-Button-Menu", "Bottom-Button-Menu-" + Size);
		else { $S_Class("Bottom-Button-Menu", "Bottom-Button-Menu-Mini") }
	}
	catch(e){}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Section
//  PARAMS >> Sec (String)
//*************************************************************
function GADGET_Section(Sec)
{
	var Height = UTIL.VAR_Read("Size_Height", "1");
	var Size   = UTIL.VAR_Read("Temp_Size", "SM");
	
	if (Sec == "Me")
	{
		$S_Class("Main-Sec-Me", '');
		$S_Class("Main-Sec-Friends", "Hidden");
		$S_Class("Bottom-Button-Me", "Bottom-Button-Me-" + Size + "-Active");
		$S_Class("Bottom-Button-Friends", "Bottom-Button-Friends-" + Size);

		$S_Hide("Me-Label-Name-SM");
		$S_Hide("Me-Label-Name-LG");
		$S_Show("Me-Label-Name-" + Size);
	}
	else
	{
		$S_Class("Main-Sec-Me", "Hidden");
		$S_Class("Main-Sec-Friends", '');
		$S_Class("Bottom-Button-Me", "Bottom-Button-Me-" + Size);
		$S_Class("Bottom-Button-Friends", "Bottom-Button-Friends-" + Size + "-Active");
		GADGET_Feed_Stream_Reset();
	}
	UTIL.VAR_Write("Temp_Section", Sec);
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Stream (Up)
//  PARAMS >> X | String
//*************************************************************
function GADGET_Stream_Up(X)
{
	try
	{
		var parent = $S("Scrollholder");
		if (X == "Go")
		{
			dw_scrollObj.initScroll(parent.id, "up");
			clearInterval(mouseWheelTimer);
		}
		else { mouseWheelTimer = mouseStop(parent.id) }
	}
	catch(e){}
}

//*************************************************************
//  GADGET >> Stream (Down)
//  PARAMS >> X | String
//*************************************************************
function GADGET_Stream_Down(X)
{
	try
	{
		var parent = $S("Scrollholder");
		if (X == "Go")
		{
			dw_scrollObj.initScroll(parent.id, "down");
			clearInterval(mouseWheelTimer);
		}
		else { mouseWheelTimer = mouseStop(parent.id) }
	}
	catch(e){}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Feed: Refresh
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Refresh()
{
	$S_Class("UI-Button-Omni", "UI-Button-Omni-Loading");
	$S("UI-Button-Omni").title = "Loading...";
	UTIL.VAR_Write("Temp_Flag_Refresh_User", '');
	UTIL.VAR_Write("Temp_Flag_Refresh_Stream", '');
	GADGET_Feed_User_Start();
	GADGET_Feed_Stream_Start();
}

//*************************************************************
//  GADGET >> Feed: Refresh (Gate)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Refresh_Gate()
{
	var Flag_User   = UTIL.VAR_Read("Temp_Flag_Refresh_User");
	var Flag_Stream = UTIL.VAR_Read("Temp_flag_Refresh_Stream");
	var Offline     = UTIL.VAR_Read("Offline", "Off");
	
	if (Flag_User == "On" && Flag_Stream == "On")
	{
		setTimeout('$S_Class("UI-Button-Omni", "UI-Button-Omni-Gear"); $S("UI-Button-Omni").title = "Quick Options / Alerts";', 200);
		if (Offline == "On")
		{
			UTIL.VAR_Write("Offline", "Off");
			UTIL.STOR_Save();
			$S_Class("UI-Button-Omni", "UI-Button-Omni-Gear");
			$S("UI-Button-Omni").title = "Quick Options / Alerts";
		}
		if (UTIL.VAR_Read("Mode", "Full") == "Mini") GADGET_Feed_Display_Mini(); 
	}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Feed: User (Start)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_User_Start()
{
	try
	{
		var URL = INFO.URL_FB_API_Batch.replace(/FB_UID/g, UTIL.VAR_Read("FB_UID")) + "&" + UTIL.VAR_Read("FB_Access");
		AJAX_User = UTIL.AJAX_Create(GADGET_Feed_User_End, "GET", URL, true);
		AJAX_User.send()
	}
	catch(e){ GADGET_OMNI_Alert("Connection Error: User data is not sending.") }
}

//*************************************************************
//  GADGET >> Feed: User (End)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_User_End()
{
	if (UTIL.AJAX_Check(AJAX_User, true)) 
	{
		try
		{
			var Res = AJAX_User.responseText;
			$S_Text("Gadget-User", Res);
			UTIL.FILE_Save("FB-Data-User.txt", UTIL.JSON_Encode(Res));
			if (UTIL.VAR_Read("Mode", "Full") == "Full") GADGET_Feed_Display_User();
			
			//>> Trigger Gate
			UTIL.VAR_Write("Temp_Flag_Refresh_User", "On");
			GADGET_Feed_Refresh_Gate();
		}
		catch(e){ GADGET_OMNI_Alert("Connection Error: User data is not loading properly.") }
	}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Feed: Stream (Start)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Stream_Start()
{
	try
	{
		var URL = INFO.URL_FB_Graph_Stream + UTIL.VAR_Read("FB_Access");
		URL += "&limit=" + UTIL.VAR_Read("Number_Stream_Items", "25");
		AJAX_Stream = UTIL.AJAX_Create(GADGET_Feed_Stream_Mid, "GET", URL, true);
		AJAX_Stream.send()
	}
	catch(e){ GADGET_OMNI_Alert("Connection Error: Friend activity data is not sending.") }
}

//*************************************************************
//  GADGET >> Feed: Stream (Mid)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Stream_Mid()
{
	if (UTIL.AJAX_Check(AJAX_Stream, true)) 
	{
		try
		{
			var Res = AJAX_Stream.responseText;
			$S_Text("Gadget-Stream", Res);
			UTIL.FILE_Save("FB-Data-Stream.txt", Res);
			
			//>> Parse UIDs
			var Res_Parse = UTIL.JSON_Parse(Res);
			var Str = '';
			var i = 0;

			while (i < Res_Parse.data.length)
			{
				var UID = Res_Parse.data[i].from.id;
				if (Str.indexOf(UID + ",") <= -1)
				{
					Str += UID;
					if ((i + 1) != Res_Parse.data.length) Str += ",";
				}
				i++;
			}
			var URL = INFO.URL_FB_API_Users + "uids=" + Str + "&" + UTIL.VAR_Read("FB_Access");
			AJAX_Profiles = UTIL.AJAX_Create(GADGET_Feed_Stream_End, "GET", URL, true);
			AJAX_Profiles.send()
		}
		catch(e){ GADGET_OMNI_Alert("Connection Error: Friend activity data is not loading properly.") }
	}
}

//*************************************************************
//  GADGET >> Feed: Stream (End)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Stream_End()
{
	if (UTIL.AJAX_Check(AJAX_Profiles, true)) 
	{
		try
		{
			var Res = UTIL.JSON_Parse(AJAX_Profiles.responseText);
			var Str = '';
			var i = 0;

			while (i < Res.length)
			{
				Str += "<div id='Profile-" + Res[i].uid + "-Pic'>" + Res[i].pic_square + "</div>";
				i++;
			}
			$S_HTML("Gadget-Profiles", Str);
			if (UTIL.VAR_Read("Mode", "Full") == "Full") GADGET_Feed_Display_Stream();

			//>> Trigger Gate
			UTIL.VAR_Write("Temp_Flag_Refresh_Stream", "On");
			GADGET_Feed_Refresh_Gate();
		}
		catch(e){ GADGET_OMNI_Alert("Connection Error: Friend profile data is not loading properly.") }
	}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Feed: Display (User)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Display_User()
{
	try
	{
		//>> Get Feed
		var Res        = UTIL.JSON_Parse($S("Gadget-User").innerText);
		var Res_User   = UTIL.JSON_Parse(Res[0]);
		var Res_Status = UTIL.JSON_Parse(Res[1]);
		var Res_Msgs   = UTIL.JSON_Parse(Res[2]);
		var Res_Notif  = UTIL.JSON_Parse(Res[3]);

		//>> Get Variables
		var Notif_ID     = UTIL.VAR_Read("Notifications_ID");
		var Profile_Link = UTIL.VAR_Read("Profile_Link", "Wall");
		var Size         = UTIL.VAR_Read("Temp_Size", "SM");
		var Notif_Count  = 0;
		var i            = 0;

		//>> Parse User Info
		var User_First  = Res_User[0].first_name;
		var User_Last   = Res_User[0].last_name;
		var User_Pic    = Res_User[0].pic_square;
		var User_Name   = User_First + "&nbsp;" + User_Last;
		var User_Status = '';
		if (User_Pic == '' || User_Pic == undefined) User_Pic = "Images/BG/Placeholder.gif";

		//>> Parse User Status
		try
		{
			User_Status = Res_Status[0].message;
			if (User_Status == undefined || User_Status == '' || User_Status == null) User_Status = "Status not set or cleared.";
		}
		catch(e){ User_Status = "Status not set or cleared." }

		//>> Parse User Notifications
		try
		{
			while (i < Res_Notif.notifications.length)
			{
				var Notif_ID_Temp = Res_Notif.notifications[i].notification_id;
				if (Notif_ID != Notif_ID_Temp) Notif_Count++;
				else break;
				i++;
			}
			if (Notif_Count > 0)
			{
				$S_HTML("Me-Button-Notifications-Count", Notif_Count);
				$S_Class("Me-Button-Notifications", "Me-Button-Notifications-" + Size + "-Active");
				UTIL.VAR_Write("Temp_Notif_Count", Notif_Count);
			}
			else { UTIL.VAR_Write("Temp_Notif_Count", '') }
		}
		catch(e){}

		//>> Parse User Message Counts
		var User_Pokes    = Res_Msgs.pokes.unread;
		var User_Messages = Res_Msgs.messages.unread;
		var User_Friends  = Res_Msgs.friend_requests.length;
		var User_Events   = Res_Msgs.event_invites.length;
		var User_Groups   = Res_Msgs.group_invites.length;

		if (User_Friends == undefined) User_Friends = 0;
		if (User_Events == undefined) User_Events = 0;
		if (User_Groups == undefined) User_Groups = 0;

		//>> Temp Save Data
		UTIL.VAR_Write("Temp_User_First", User_First);
		UTIL.VAR_Write("Temp_User_Last", User_Last);
		UTIL.VAR_Write("Temp_User_Pic", User_Pic);
		UTIL.VAR_Write("Temp_User_Status", User_Status);

		//>> Set User Info
		try
		{
			$S_HTML("Me-Label-Icon", "<img src='" + User_Pic + "' />");
			$S_HTML("Me-Label-Name-LG-Top", UTIL.STR_Cut(User_Name, 26));

			if (User_Name.length > 18 || UTIL.VAR_Read("Override_User_Name", "Off") == "On")
			{
				$S_HTML("Me-Label-Name-SM-Top", UTIL_STR_Cut(User_First, 17));
				$S_HTML("Me-Label-Name-SM-Bottom", UTIL_STR_Cut(User_Last, 17));
			}
			else
				{ $S_HTML("Me-Label-Name-SM", "<div id='Me-Label-Name-SM-Center'>" + User_Name + "</div>"); }

			if (Profile_Link == "Wall")
			{
				$S("Me-Label").title = "Click here to view your wall";
				$S_HTML("Me-Label-Name-LG-Bottom", "Click here to view your wall");
			}
			else if (Profile_Link == "Profile")
			{
				$S("Me-Label").title = "Click here to launch profile";
				$S_HTML("Me-Label-Name-LG-Bottom", "Click here to launch profile");
			}
		}
		catch(e){}

		//>> Set User Status
		try
		{
			if (Size == "SM") $S_HTML("Me-Status-Box", UTIL.STR_Cut(User_Status, 80));
			else if (Size == "LG") $S_HTML("Me-Status-Box", UTIL.STR_Cut(User_Status, 130));
		}
		catch(e){}

		//>> Set User Messages
		try
		{
			$S_HTML("Me-Message-Poke-Count", "(" + User_Pokes + ")");
			$S_HTML("Me-Message-Msg-Count", "(" + User_Messages + ")");
			$S_HTML("Me-Message-Friend-Count", "(" + User_Friends + ")");
			$S_HTML("Me-Message-Events-Count", "(" + User_Events + ")");
			$S_HTML("Me-Message-Groups-Count", "(" + User_Groups + ")");
		}
		catch(e){}

		//>> Hide Loading
		$S_Hide("Me-Label-Loading");
		$S_Show("Me-Label-Main");
	}
	catch(e){}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Feed: Display (Stream)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Display_Stream()
{
	try
	{
		//>> Get Variables
		var Stream = $S("Gadget-Stream").innerText;
		if (Stream != '')
		{
			Stream = UTIL.JSON_Parse(Stream);
			var Size = UTIL.VAR_Read("Temp_Size", "SM");
			if (Size == "SM") var Font_Size = UTIL.VAR_Read("Font_Size_Docked", "10");
			else { var Font_Size = UTIL.VAR_Read("Font_Size_Undocked", "12") }
			var Str = '';
			var i = 0;
	
			//>> Reset Scroller Area
			$S_HTML("Scrollholder", "<div id='Scroll' class='Friends-Stream-Scroll Friends-Stream-Scroll-" + Size + "'></div>");
	
			//>> Parse Stream
			while (i < Stream.data.length)
			{
				try
				{
					//>> Parse Variables
					var Entry_ID = Stream.data[i].id;
					var Entry_Type = Stream.data[i].type;
					var Entry_From_User = Stream.data[i].from.name;
					var Entry_From_ID = Stream.data[i].from.id;
					var Entry_Message = Stream.data[i].message;
					var Entry_Picture = Stream.data[i].picture;
					var Entry_Name = Stream.data[i].name;
					var Entry_Caption = Stream.data[i].caption;
					var Entry_Description = Stream.data[i].description;
					try { var Entry_From_Pic = $S("Profile-" + Entry_From_ID + "-Pic").innerHTML; }
					catch(e) { var Entry_From_Pic = "http://graph.facebook.com/" + Entry_From_ID + "/picture"; }
					var Stream_Msg = '';
	
					if (Entry_Type == "status")
					{
						if (Size == "SM") Stream_Msg = UTIL.STR_Cut(Entry_Message, 45);
						else Stream_Msg = Entry_Message;
						var Stream_Title = Entry_Message;
					}
					else
					{
						if (Entry_Message != undefined) Stream_Msg += Entry_Message;
						if (Stream_Msg == '' && Entry_Name != undefined) Stream_Msg += Entry_Name;
						if (Stream_Msg == '' && Entry_Caption != undefined) Stream_Msg += Entry_Caption;
						if (Stream_Msg == '' && Entry_Description != undefined) Stream_Msg += Entry_Description;
						Stream_Msg = GADGET_Link_Check(Stream_Msg);
						var Stream_Title = Stream_Msg;
						if (Size == "SM") Stream_Msg = UTIL.STR_Cut(Stream_Msg, 45);
					}
	
					Stream_Msg = Stream_Msg.replace(/>/g, "&lt;");
					Stream_Msg = Stream_Msg.replace(/</g, "&gt;");
	
					if (Entry_Picture != undefined && Entry_Picture != '')
					{
						Stream_Msg += "<div style='text-align: center;'><img src='" + Entry_Picture + "' ";
						Stream_Msg += "class='Stream-Entry-Photo Stream-Entry-Photo-" + Size + "' /></div>";
					}
	
					//>> Build Entry
					Str += "<div id='Entry-" + i + "' class='Stream-Entry Stream-Entry-" + Size + "' title='";
						if (Entry_Type == "status") Str += Entry_From_User.replace(/'/g, "&prime;") + ": " + Stream_Title.replace(/'/g, "&prime;");
						else Str += Entry_From_User.replace(/'/g, "&prime;") + ": " + Stream_Title.replace(/'/g, "&prime;") + " (Posted a " + Entry_Type + ")";
					Str += "' onclick='GADGET_Flyout_Entry(\"" + Entry_ID + "\");' style='font-size: " + Font_Size + "px;'>";
						Str += "<img src='" + Entry_From_Pic + "' class='Stream-Entry-Pic' />";
						if (Size == "SM") Str += "<small>";
							Str += "<strong>" + Entry_From_User + "</strong>: " + Stream_Msg;
						if (Size == "SM") Str += "</small>";
					Str += "</div>";
				}
				catch(e){}
	
				i++;
			}
		}
		$S_HTML("Scroll", Str);
		ScrollLoad("Scrollholder", "Scroll", false);
	}
	catch(e){}
}

//*************************************************************
//  GADGET >> Feed: Stream Reset
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Stream_Reset()
{
	try
	{
		var Str = $S("Scroll").innerHTML;
		$S_HTML("Scrollholder", "<div id='Scroll' class='Friends-Stream-Scroll Friends-Stream-Scroll-" + UTIL.VAR_Read("Temp_Size", "SM") + "'></div>");
		$S_HTML("Scroll", Str);
		ScrollLoad("Scrollholder", "Scroll", false);
	}
	catch(e){}
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Feed: Display (Mini)
//  PARAMS >> None
//*************************************************************
function GADGET_Feed_Display_Mini()
{
	try
	{
		var Res       = UTIL.JSON_Parse($S("Gadget-User").innerText);
		var Res_Msgs  = UTIL.JSON_Parse(Res[2]);
		var Res_Notif = UTIL.JSON_Parse(Res[3]);
		var Notif_ID  = UTIL.VAR_Read("Notifications_ID");
		var Notif_Count = 0;
		var i = 0;
		
		//>> Parse User Notifications
		try
		{
			while (i < Res_Notif.notifications.length)
			{
				var Notif_ID_Temp = Res_Notif.notifications[i].notification_id;
				if (Notif_ID != Notif_ID_Temp) Notif_Count++;
				else break;
				i++;
			}
			$S_HTML("Mini-Message-Notif-Count",  Notif_Count);
			UTIL.VAR_Write("Temp_Notif_Count", Notif_Count);
		}
		catch(e){}

		//>> Parse User Message Counts
		var User_Pokes    = Res_Msgs.pokes.unread;
		var User_Messages = Res_Msgs.messages.unread;
		var User_Friends  = Res_Msgs.friend_requests.length;
		var User_Events   = Res_Msgs.event_invites.length;
		var User_Groups   = Res_Msgs.group_invites.length;

		if (User_Friends == undefined) User_Friends = 0;
		if (User_Events == undefined) User_Events = 0;
		if (User_Groups == undefined) User_Groups = 0;
		
		//>> Set User Messages
		try
		{
			$S_HTML("Mini-Message-Poke-Count",  User_Pokes);
			$S_HTML("Mini-Message-Msg-Count", User_Messages);
			$S_HTML("Mini-Message-Friend-Count", User_Friends);
			$S_HTML("Mini-Message-Events-Count", User_Events);
			$S_HTML("Mini-Message-Groups-Count", User_Groups);
		}
		catch(e){}
	}
	catch(e){}
}